/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Terza prova in itinere del 29/01/2008

Tempo a disposizione: 2h 30 min

Scrivere un programma per la gestione dei soci di un club e delle prenotazioni delle attivit presso il club.
I soci sono caratterizzati dalle seguenti informazioni: Nome, Cognome, numero tessera, data di iscrizione,  fascia di et (0=et <18, 1=et >= 18 && et < 60,  2=et>=60).
I soci sono inseriti in un vettore di 3 liste, una  per ogni fascia di et.
Ogni lista  ordinata rispetto al numero di tessera.
Per quanto riguarda le prenotazioni, esse sono caratterizzate dalle seguenti informazioni: numero di tessera, fascia di et, ora di prenotazione, tipo di attivit.
Ogni nuova prenotazione viene inserita in una tabella allocata dinamicamente con 4 righe, una per ogni tipo di attivit.
Linserimento di una prenotazione nella tabella viene eseguito solo se il prenotante  effettivamente iscritto al club. Per la verifica si utilizzi il numero di tessera e la fascia di et
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento ordinato in lista di un nuovo socio;
2.Visualizzazione dei soci appartenenti a una certa fascia di et;
3.Inserimento in tabella di una prenotazione dopo averne verificato l'iscrizione del prenotante;
4.Visualizzazione delle prenotazioni relative a una certa attivit.

Liberare la memoria allocata dinamicamente.

*/
#include <stdio.h>
#include <stdlib.h>

typedef struct{
	char nome[20],cognome[20],data[20];
	int tessera,fascia;
}socio;


struct atomo{
	socio dato;
	struct atomo *next;
};

typedef struct{
	int tessera,fascia,ora,tipo;
}prenotazione;


void leggi(socio *s);
void ins_ordinato(struct atomo *tl[3], socio s);
void vis_lista(struct atomo *tl[3]);
int ricerca(struct atomo *tl, int tessera);
void ins_tabella(prenotazione *T[4], int *N, int tessera, int fascia);
void vis_tabella(prenotazione *T[4], int *N);
void libera_liste(struct atomo **tl);
void menu();

main() {
	struct atomo *LS[3];
	socio s;
	prenotazione *TB[4];
	int N[4],opz,i,tessera;


	for(i=0;i<4;i++)
		{	TB[i]=NULL;
			N[i]=0;
		}
	for(i=0;i<3;i++)
		LS[i]=NULL;

	do{	menu();
		scanf("%d",&opz);
		switch(opz){
			case 1: leggi(&s);
					ins_ordinato(&LS[s.fascia],s);
					break;
			case 2: vis_lista(LS);
					break;
			case 3: printf("Inserisci il numero di tessera\n");
					scanf("%d",&tessera);
					printf("Inserisci la fascia di eta'\n");
					scanf("%d",&i);
					if(ricerca(LS[i],tessera)==1)
						ins_tabella(TB,N,tessera,i);
					else printf("Socio non presente\n");
					break;
			case 4: vis_tabella(TB,N);
					break;
			default:;
		}
	}while(opz!=0);

	for(i=0;i<3;i++)
		libera_liste(&LS[i]);
	for(i=0;i<4;i++)
		free(TB[i]);
}


void leggi(socio *s)
{
	printf("Inserisci il nome\n");
	scanf("%s",s->nome);
	printf("Inserisci il cognome\n");
	scanf("%s",s->cognome);
	printf("Inserisci il numero di tessera\n");
	scanf("%d",&s->tessera);
	printf("Inserisci la data di iscrizione\n");
	scanf("%s",s->data);
	printf("Inserisci la fascia di eta' (0,1,2)\n");
	scanf("%d",&s->fascia);

}
void ins_ordinato(struct atomo **tl, socio s)
{
	int tessera,f;
	struct atomo *aux, *l1,*l2;

	aux=malloc(sizeof(struct atomo));
	if(aux==NULL) return;
	aux->dato=s;
	tessera=aux->dato.tessera;
	f=aux->dato.fascia;

	if(*tl==NULL || tessera<(*tl)->dato.tessera)
		{	aux->next=*tl;
			*tl=aux;
			return;
		}
	l2=*tl;
	l1=l2->next;

	while(l1!=NULL)
		{	if(tessera<l1->dato.tessera)
				break;
			else { l2=l1;
					l1=l1->next;
				 }
		}

	l2->next=aux;
	aux->next=l1;
}



void vis_lista(struct atomo *tl[3])
{
	int fascia;
	struct atomo *aux;

	printf("Inserisci la fascia da visualizzare\n");
	scanf("%d",&fascia);

	aux=tl[fascia];
	while(aux!=NULL)
		{	printf("Nome %s\n",aux->dato.nome);
			printf("Cognome %s\n",aux->dato.cognome);
			printf("Tessera %d\n",aux->dato.tessera);
			printf("data %s\n",aux->dato.data);
			printf("fascia %d\n",aux->dato.fascia);
			aux=aux->next;
		}


}


int ricerca(struct atomo *tl, int tessera)
{

	while(tl!=NULL)
		if(tessera==tl->dato.tessera)
				return 1;
			else tl=tl->next;
	return 0;
}


void ins_tabella(prenotazione *T[4], int *N, int tessera, int f)
{
	int trovato=0;
	struct atomo *aux;
	prenotazione p,*R;

	p.tessera=tessera;
	p.fascia=f;
	printf("Inserisci l'ora di prenotazione\n");
	scanf("%d",&p.ora);
	printf("Inserisci il tipo di attivita'\n");
	scanf("%d",&p.tipo);


	R=realloc(T[p.tipo],sizeof(prenotazione)*(N[p.tipo]+1));
	if(R==NULL) return;

	T[p.tipo]=R;
	T[p.tipo][N[p.tipo]]=p;
	N[p.tipo]++;


}


void vis_tabella(prenotazione *T[4], int *N)
{
	int tipo,i;
	printf("Inserisci il tipo di attivita'\n");
	scanf("%d",&tipo);

	for(i=0;i<N[tipo];i++)
		{	printf("Tipo di attivita' %d\n",T[tipo][i].tipo);
			printf("Numero tessera %d\n",T[tipo][i].tessera);
			printf("Ora di prenotazione %d\n",T[tipo][i].ora);
			printf("Fascia di eta' %d\n\n",T[tipo][i].fascia);
		}
}
void libera_liste(struct atomo **tl)
{
	struct atomo *aux;
	while(*tl!=NULL)
		{	aux=*tl;
			*tl=aux->next;
			free(aux);
		}
}
void menu(){
	printf("Scegli tra\n");
	printf("1) Inserimento in lista di un socio\n");
	printf("2) Visualizza una lista\n");
	printf("3) Inserimento di una prenotazione\n");
	printf("4) Visualizza tabella\n");
	printf("0) Esci\n\n");
}
